package QueryMac;

#!/usr/local/bin/perl -w

#-------------------------
#
# Program name: QueryMac.pm
# Created by: The Sporting Cristal Group:
#             Archana Bellamkonda
#             Rashmi Kankaria
#             Ashutosh Nagle
#             Paul Gordon
#
# Date: 11/13/02
# 
# Run 'perldoc' on this file to produce documentation
#
# Copyright 2002 by The Sporting Cristal
#
# This module is free software; you can redistribute it and/or modify
# it under the same terms as Perl itself.
#
#-------------------------


use 5.008;
#use strict;
use warnings;

use Exporter;

@ISA = qw(Exporter) ;

@EXPORT = qw(interface thesFindList) ;
@EXPORT_OK = qw( initialize getDefs lookup printlookup thesFind retrieveEntry numRecords ) ;

our $VERSION = '0.01';

# Taken from WordNet::QueryData module by Jason Rennie
#

my $bmHome = defined($ENV{"BMHOME"}) 
? $ENV{"BMHOME"} : "/home/cs/tpederse/CS8761/BigMac/";


$flag = 0 ;
$initializeFlag = 0 ;
$fh = OUTPUTFILEHANDLE ;


sub initialize {

    # Commented out 12/13 p.g.

    #$check = shift ;
    #	if ( defined( $check ) ) {
    #	open FH, ">test.txt" || die "Could not open test.txt for writing: $!\n" ; $flag = 1 ;

    #}
    
     # Commented out 12/13 p.g.

    #$flag = 0 ; # global variable for printing to file
    
    
    $initializeFlag = 1 ;
    
    my $str ;
    
    print "\nInitializing dictionary, please wait...\n" ;

    # Store entries in data structure keyed on Headword
    %defsHash = () ; # global index
    
    # Open dictionary file
    #
    open DIC_READ_FH, "$bmHome/bigmac.corrected2.sgml" || 
	die "Counldn't open bigmac.sgml in lookup: $!\n" ;
    
    while ( $str = <DIC_READ_FH> ) {
	if( $str =~ /<HEAD\>(.*?)</ ) {
	    # Concatinate entries with same Headword
	    $defsHash{$1} .= $str ;
	}
    }

}

# Simple menu to select options
sub interface {
    my $choice = -1 ;
    my $word ;
    my $POS ;
    
    initialize() ;

    print "do you want to print results to test.txt?\n" ;
    chomp ( $answer = <STDIN> ) ;
    if ( $answer =~ /[yY]/ ) { open $fh , ">test.txt" || die "Could not open test.txt for writing: $!\n" ; $flag = 1 ; }

    while ( $choice != 0 ) {
	print "0. Exit\n" ;
	print "1. Enter a word and search for definitions\n" ;
	print "2. Enter a word and part of speech and earch for definitions\n" ;
	print "3. Enter a word or words and search for all defininitions containing the word or words\n" ;
	print "4. Enter a word and search for all other similar words\n" ;

	chomp ( $choice = <STDIN> ) ;

	if ( $choice == 0 ) { exit ; }
	# Needs seperate instructions
	if ( $choice == 3 ) { print "Enter word or words (separated by spaces)\n" ; $word = <STDIN> ; 
			      getDefs("$word"); next ; }

	print "Enter word\n" ;
	$word = <STDIN> ;
	chomp ( $word ) ;

	if ( $choice == 1 ) { printlookup(lookup("$word") ) ; next ; }
	if ( $choice == 2 ) { print "Enter Part of Speech\n" ; chomp ( $POS = <STDIN> ) ; 
			      printlookup( lookup("$word", "$POS" ) ) ; next ; }
	if ( $choice == 4 ) { thesFindPrint("$word") ; next ; } 
    
    }
}

# Function returns all definitions, in every entry in dictionary which contains the
# key word or words.  It also returns the head word and part of speech.  The syntax is
#
# headword, part of speach, thes number (if it exists) : definition
#
sub getDefs {

    my $word = shift ;
    my $str ;
    my $name ;
    my $count = 0 ;
    my $def ;
    my $pos ;
    my $entry ;
    @listofDefs = ();

    # Get the list of words to search for 
    @list = split /\s*;\s*/, $word ;
    foreach (@list) { chomp ; }
    #
    # Search through every entry in dictionary
    foreach $keys ( keys %defsHash ) {
	# initialize each time
	@listOfDefs = () ;
	# Store entry in a string...
	$_ = $defsHash{$keys} ;
	$entry = $_ ;
	# Extract all definitions from entry and store in array.
	@listOfDefs = /<DTEXT\>(.*?)<\/DTEXT\>/ ;
	# Check each definition for all the key words.
	foreach $def ( @listOfDefs ) {
	    #
	    foreach $name ( @list ) {
		if ( $def =~/\b$name\b/ ) { $count++ ; next ; }
		# if any word fails, go to the next entry.
		else {last ; }
	    }
	    # if...then all words matched, process definition.
	    if ( $count == @list ) {
		# Variable local to the if statement.
		my $thes = () ;
		# ugly hack -- /$var/ treats $var as a regex, not a literal
		# which causes trouble when defs have parenthesis
		# So just match up to first parenthesis
		# I know there is a better way, I just don't know what it is
		#
		$temp = $def ;
                @temp = split /\(/ , $def ;
		# If we don't match, there's a problem.
		if( ! ( $entry =~ /<POS\>(.+?)<\/POS>.*$temp[0]/ ) ) { 
		    $pos = "none" ;  } #print "\nProblem, POS didn't match.  Dollar temp: $temp[0]\n\n" ; exit ; }
		else { $pos = $1 ; } 
		# The first match is for "regular" entries, the second for phrases
		if( $entry =~ /<DEF.*?$temp[0].*?<THES\>(.*?)<\/THES\>.*?<\/DEF\>/ ) {
		    $thes = $1 ;
		} 
		if( $entry =~ /<SUBDEF.*?$temp[0].*?<THES\>(.*?)<\/THES\>.*?<\/SUBDEF\>/ ) {
		    $thes = $1 ;
		} 
		#
		if ( $flag == 0 ) {
		    if( defined($thes) ) { print $keys.", ".$pos.", ".$thes.": ".$def, "\n\n" ; } 
		    else { print $keys.", ".$pos.": ".$def, "\n\n" ; }
		}
		else {
		    print "printing to file...\n" ;
		    if( defined($thes) ) { print $fh $keys.", ".$pos.", ".$thes.": ".$def, "\n\n" ; } 
		    else { print $fh $keys.", ".$pos.": ".$def, "\n\n" ; }
		}
	    }
	    $count = 0 ;
	}
    }
    
    
}


sub thesFind {
    
    my $word = shift ;
    my $string ;
    my $example ;
    my $thesExample ;
    
    # hash to entry of given word
    #
    $_ = $defsHash{$word} ;
    # grap all the thesaurus entries
    #
    
    @thesArray = /<THES\>(.*?)<\/THES\>/g ;
    
    # Convert arrar into hash
    # This is done to easily check for duplicate
    # thesaurus entries
    #
    foreach ( @thesArray )
    {
	$thesHash{$_}++ ;
    }
    
    # header for thesaurus list
    #
    #foreach ( keys %thesHash ) { print "$word\t$_\n\n" ; }
    
    # For each entry in dictionary
    foreach $key  ( keys %defsHash ) {
	#
	$string = $defsHash{$key} ;
	# for each thesaurus entry
	foreach $example ( keys %thesHash ) {
	    if ( $string =~ /<THES\>$example<\/THES\>/ ) {
		# if the dictionary entry contains the thesaurus entry
		# add headword to an array named after the thesaurus entry
		push @{$example} , $key ;
	    }
	}
    }

    return %thesHash ;

}

sub thesFindPrint {
    
    my $word = shift ;
    my %rtnHashOne ;
    my $thesExample ;

    # Ok, now we have all the headwords associated with each thesaurus entry
    # let's print them.
    #
    
    %rtnHashOne = thesFind($word) ;
    
    foreach $thesExample ( keys %rtnHashOne ) {
	# \$thesExample is the name of the array associated with that thes. entry
	if( $flag == 0 ) { print "\n$word\t$thesExample\n" ; }
	else { print $fh "\n$word\t$thesExample\n" ; }
	#
	#print "Count of $thesExample equals " , scalar @{$thesExample} , "\n" ;
	foreach ( @{$thesExample} ) {
	    if( $_ ne $word ) { 
                if ( $flag == 0 ) { print "$_\n" ; }
		else {
		    print "printing to file...\n" ; 
		    print $fh "$_\n" ; 
		}
	    }
        }

    }    

}

sub thesFindList {

    my $word = shift ;
    my %rtnHashOne ;
    my %CombinedList ; 
    my $thesExample ;
    
    print "initializing dictionary\n" ;
    
    if ( $initializeFlag == 0 ) { initialize() ; }
    print "done initializing\n" ;
    
    %rtnHashOne = thesFind($word) ;
    
    foreach $thesExample ( keys %rtnHashOne ) {
	# \$thesExample is the name of the array associated with that thes. entry
        #
	#print "Count of $thesExample equals " , scalar @{$thesExample} , "\n" ;
	foreach ( @{$thesExample} ) {
	    $combinedList{$_} = 0 ;
        }
	
    }

    return %combinedList ;
    
    #foreach ( keys %combinedList ) { print "$_\n" ; }
    
}


sub printlookup {
    #print "ARGS: @_\n" ;
    my %word ;
    my $pos ;

	# hash of arrays passed as a list of key (POS)-- value ( array of definitions)
	# pairs.  This combines them back into a single hash of arrays.
	#

    #print "**@_**" ; 
    if( !@_ ) { print "Entry not found\n" ; return ; }
 
    while (@_) {
	$pos = shift @_ ; # get the key ;
	$word{$pos} = (shift @_) ; # assign value to key
    }

    # from p. 277 of "Programming Perl" by Larry Wall, et. al.
	# print the hash of arrays.
	# May have to switch to an array of arrays.  Hash has its
	# own order, so phrases are interspersed randomly among
	# the other definitions.
	# If sorted, phrases come before verbs.

	#print "\n******************************************\n" ;

if( $flag== 0 ){ 
    for $pos ( sort keys %word ) {
	print "\n$pos:\n\n" ;
		for $i ( 0..$#{$word{$pos}} ) {
			print "$word{$pos}[$i]\n" ;
		}
    }
}
    else {
    for $pos ( sort keys %word ) {
	print $fh "\n$pos:\n\n" ;
		for $i ( 0..$#{$word{$pos}} ) {
		print "printing to file...\n" ;	
		    print $fh "$word{$pos}[$i]\n" ;
		}
    }
}
	#print "\n******************************************\n" ;

}

sub lookup {
    my $word = shift ;
    my $posName = shift ;
    my %word = () ;
    my $POS ;
    my @strMatch ;
    my @defs ;
    my $spPart ;
    my $str ;
    my @phPart ;
    my @sd ;
    my $phraseName ;
    
    # Open dictionary file
    #
    open DIC_READ_FH , "$bmHome/bigmac.sgml" || 
	die "Counldn't open bigmac.sgml in lookup: $!\n" ;
    
#    while ( <FH> ) {
#	# Concatenate multiline entries into single line
#	while (!/<\/RECORD\>\W*$/) {
#	    #chomp ( $_ .= <FH>  ) ;
#	    if( defined( $temp = <FH> ) ) {
#		$_.=$temp ;
#	    }
#	    else { return ( %word = ()  ) ; }
#	}
	# When desired entry is found...
#	if( /<HEAD\>($word)</ ) {
		# Divide the entry into "Chunks" -- sections containing
		# definitions for a single part of speech.
	    #
# NEW method -- used initialization info
#
    if ( !defined( $_ = $defsHash{$word} ) )  { return %word ; }
    
    @strMatch = /<CHUNK\>(.*?)<\/CHUNK\>/g ;
    # Now that it's divided, and each Chunk is an entry in
    # strMatch...
    #
    foreach (@strMatch) {
	# store part of speech tag.
	#
	$_ =~ /<POS\>(.*?)<\/POS\>/ ;
	$spPart = $1 ;
	# This is the case when a part of speech is include as a second
	# arguement.  If a second arguement exists, and it is not equal
	# to the current part of speech, don't save the info in this Chunk.
	#
	if( defined( $posName ) && $posName ne $spPart ) { next ; }
	# Definately a case of what Mr. Wall would call "false laziness"
	# This should be abstracted out.
	# If part of speech is 'phrase', we need to subdivide the phrase
	# chunk into the different phrases ( ie 'bear up' and 'bear down' )
	#
	if( $spPart eq "phrase" ) { 
	    # divide into different phrases
	    @phPart = /<DEF\s+id=\d+\>(.*?)<\/DEF\>/g ;
	    foreach $defline ( @phPart ) {
		# for each, get the phrase ('bear up', ect.)
		$defline =~ /<SUBHEAD\>(.*?)<\/SUBHEAD\>/ ;
		$subPhrase = $1 ;
		$_ = $defline ;
		# This is a little messy.
		# We need to divide by a large enough slice so that we include
		# both a single definition, and any possible Thesaurus entry.
		# The SUBDEF tag works perfectly for this...
		@sd = /<SUBDEF(.*?)<\/SUBDEF\>/g ;
		# But unfortunately, if a phrase has only on definition, it has
		# no SUBDEF tag.
		# In this case, we push back on the original phrase section.
		# since there is only one definition, we don't need to divide
		# it into SUBDEFS.
		if( (scalar @sd) == 0 ) {
		    push @sd, $defline ;
		}
		# Now we look for the definition and any THES entry.
		# if there is THES entry, the " (THES)" string is appended
		# to the definition.
		#
		foreach $subD (@sd) {
		    if( $subD =~ /<DTEXT\>(.*?)<\/DTEXT\>/ ) {
			$tmp = $1 ;
			if( $subD =~ /<THES\>(.*?)<\/THES\>/ ) {
			    $tmp .= " (THES)" ;
			}
			push @sds, $tmp ;			    
		    }
		}
		# Finally add each phrase and its associated definitions to
		# the hash of arrays that will be returned
		#
		$phraseName = "phrase: ".$subPhrase ;
		$word{$phraseName}=[ @sds ] ; 
		@sds = () ;
	    } #fe
	    next ;
	}
	# The simpler case where the part of speech is not a phrase
	# Divide into definitions, pull out the definition
	# append a string to the definition if it contains
	# a THES entry and add it to the hash.
	#
	@defNew = /<DEF(.*?)<\/DEF\>/g ;
	foreach $defline ( @defNew ) {
	    if ($defline =~ /<DTEXT\>(.*?)<\/DTEXT\>/ ) {
		$tmp = $1 ;
		if( $defline =~ /<THES\>(.*?)<\/THES\>/ ) {
		    $tmp .= " (THES)" ;
		}
		push @defs, $tmp ;
	    }
		}
	$word{$spPart} = [ @defs ] ;
    }#fe$str
	# reutrn the hash of arrays.
	return %word ;
    #}#ifHEAD	
    #}#whileFH
}#sublookup
    
# Utility function to return a single entry from the bigmac.sgml file.   
    sub retrieveEntry {
	my $word = pop ;
	
	open DIC_READ_FH, "$bmHome/bigmac.corrected2.sgml" || 
	    die "Counldn't open bigmac.sgml in retrieveEntry: $!\n" ;
	while (<DIC_READ_FH>) {
	    if( /<HEAD\>$word</ ) {
		print ;
		while ( !/<\/RECORD\>/ ) {
		    print $_ = <DIC_READ_FH> ;
		}#whileRECORD
		    return ;
	    }#ifHEAD
	    }#whileFH
	}#sub
    
# another utility funciton
    sub numRecords {
	my $count ;
	open DIC_READ_FH, "$bmHome/bigmac.corrected2.sgml" || 
	    die "Counldn't open bigmac.sgml in numRecords: $!\n" ;
	while(<DIC_READ_FH>) {
	    if( /<RECORD/ ) { $count++ ; }
	}
	return $count ;
    }

# Preloaded methods go here.

1;

__END__

# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

BigMac::QueryMac - Perl extension for Macquarie Electronic
Dictionary ( aka "Big Mac" ).

=head1 SYNOPSIS

  use BigMac::QueryMac;

  interface() ; # calls menu program
  
  %bear = lookup( "bear" ) ;
  %bearVi = lookup( "bear", "verb (i)" ) ;

  printlookup( lookup( "bear" ) ) ;
  printlookup( lookup( "bear", "verb (i)" ) ) ;

  thesFind( "bear" ) ; # prints to standard output
  
  getDefs( "bear" ) ;
  getDefs( "canine", "tooth" ) ;
  getDefs( "canine, "tooth, "eye" ) ;

=head1 ABSTRACT

Bigmac::QueryMac is an interface for the Macquarie Electronic
Dictionary ( aka "Big Mac" ).  Currently the interface accepts
a word or a word and a part of speech, and returns the associated
definitions, either by printing them to STDOUT, or by saving
them in a "hash of arrays" data structure, where the parts of speech
for the lookup word are the hash keys, and the array of definitions
associated with each part of speech is the value.  QueryMac also accepts
a word as input and then returns a seperate list for each thesaurus entry
in the dictionary entry for the given word.  Each list contains all the
other headwords that have the same thesaurus entry.  Finally, QueryMac allows
a user to enter one or more words, and it will return all of the definitions
that include that combination of words. The form in which it is returned is:

headword, part of speech, thesaurus entry (if it exits) : definition.

Invoking interface(), will provide a menu with the options available in QueryMac.


=head1 DESCRIPTION

This beta release has 5 user funciton interface, interface(), getDefs(), thesFind, 
printlookup() and lookup().

lookup accepts as arguements either a word, or a word and a part of speech.  It returns 
a data structure -- a hash of arrays.

Parts of speech include:

noun
plural noun
verb (t)
verb (i)
adjective
adverb
phrase

When the part of speech is 'phrase', the output is further divided.  Each phrase will 
have its own array.  For example, the entry for 'bear' contains 'bear up' and 
'bear down'. Each of these will have their own array of definitions.  The hash keys 
being 'phrase: phrasename'.  So for the above examples, 
the keys would be 'phrase: bear up' and 'phrase: bear down'.

The printlookup() function takes as an arguement the data structure returned by lookup.
It prints the information in the following format:

 POS: pos1
 
 Def1
 Def2
 .
 .
 etc.
  
 POS: pos2
 
 Def1
 Def2

The function can be accessed in either of two ways.  Using the hash from the example
above:

printlookup( %bear ) ;

Or both steps can be combined as:

printlookup( lookup( "bear", "verb (i)" ) ;

In either case, the following is returned:

POS: verb (i):

 to have relevance to
 to tend in course or direction; move; go
 to be located or situated
 to bring forth young, fruit, etc. (THES)

thesFind and getDefs both print to standard output.

a sample of thesFind's output ( for input "bear" )is:

 bear    190.08.30
 angle
 fleet
 warp
 fade
 square
 fall
 bear
 .
 .
 etc. 
 
 bear    362.03.20
 operator
 stag
 plunger
 bull
 .
 .
 etc.

a sample of getDefs' output (for input "canine" and "tooth") is:

 canine tooth
 eyetooth, noun, *080.07.40: a canine tooth, especially of the upper jaw (so named from its position under the eye).

 dogtooth, noun, 188.02.10: a canine tooth.

 cuspid, noun, 080.07.40: a tooth with a single projection point or elevation; a canine tooth (<I>cuspid</I> 
                          is preferred for a human canine tooth).

=head2 EXPORT

	interface() by default


=head1 AUTHOR

The Sporting Cristal, E<lt>gord0156@d.umn.eduE<gt>

=head1 NOTES

Requires access to the Macquarie Electronic Dictionary ( bigmac.sgml )

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by The Sporting Cristal

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
