#Authors: Paul Gordon, Ashutosh Nagle, Rashmi Kankaria and Archana Bellamkonda
#Final Project: MRD + WEB => CORPUS
#Course:CS8761
#Course Name: NLP
#Date: Dec 6, 2002.


package ldoc;
use 5.008;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use ldoc ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(Lookup prtHash searchInDefs getWordsWithSameSub getWordsWithSameSem prtMatchingDefs prtMatchingSubCodes createIndex bypassCreateIndex prtAllPOS getAllPOS getPOSFor);

our $VERSION = '0.01';


# Preloaded methods go here.
%index4GetPOSFor = ();
%index4Lookup = ();
 
$flag4SID = 0; #Flag for the function searchInDefs
%index4SID = (); #Index for the function searchInDefs

$flag4GWWSS = 0; #Flag for functions getWordsWithSameSub and getWordsWithSameSem
%index4GWWSS = (); #Index for functions getWordsWithSameSub and getWordsWithSameSem

sub extractHWDFrom
{
	my $entry = $_[0];
	my $hwd = "";
	if ($entry =~ /<HWD>(.*?)<\/HWD>/)
	{
		$hwd = $1;
	}
	return ($hwd);
}

sub getDefsFrom
{
	my $entry = shift (@_);
	my %outDefs = ();

	while ($entry)
	{
		if ($entry !~ /<DEF>/)
		{
			last;
		}
		$entry = $';
		$entry =~ /<\/DEF>/;		
		my $def = $`; 

		while ($def =~ /<(.*?)>/)
		{
			my $tag = $1;
			$def =~ /<$tag>/;
			my $head = $`;
			my $tail = $';
			$tail =~ /<\/$tag>/;
			$tail = $';
			$def = $head.$tail;

		}
		while ($def =~ s/\(|\)//){}
		while ($def =~ /\n/)
		{
			$def = $`.$';
		}
		$outDefs{$def}=0;


	}		
	return (%outDefs);
}

sub getPOSFrom
{
	my $outStr = "";
	my $entry = $_[0];
	
	if ($entry =~ /(.*?)<POS>/)
	{
		$entry = $';
		$outStr = $`;
	} 
	elsif ($entry =~ /<\/Entry>/)
	{
		$entry = $';
		$outStr = $`;
	}		

	$_[0] = $entry;
	return $outStr;
}

sub getPOSFor
{
    my %outHash = ();
    my $word = shift (@_);
    if (!(defined($word)))
    {
	return %outHash;
    }

    if (exists($index4GetPOSFor{$word}))
    {
	return %{$index4GetPOSFor{$word}};
    }

    my $file = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    
    $word =~ /^(.)/;

    if ("\U$1" eq "E")
    {
	$file .= "e.sgm";
    }
    else
    {
	$file .= "\U$1.SGM";	
    }

    my $fh = FILEinGetPOSFor;

    if (!(open $fh,"<$file"))
    {
#	print "Error: Invalid word specified - $word\n";
	return (%outHash);
    }
    my %entries = getEntriesFor($word,$fh);

    close FILE;

    foreach my $entry (keys %entries)
    {
	while ($entry)
	{
	    if ($entry !~ /<POS>/)
	    {
		last;
	    }
	    $entry = $';
	    if ($entry !~ /<\/POS>/)
	    {
		last;
	    }
	    $entry = $';
	    my $pos = $`;
	    if ($pos !~ /\w+/)
	    {
		next;
	    }
	    $outHash{$pos}=0;
	}
    }
    $index4GetPOSFor{$word} = %outHash;
    return (%outHash);
}

sub getPOS
{
	my $c = $_[0];

	if ($c eq "n")
	{
		return "Noun";
	}

	if ($c eq "v")
	{
		return "Verb";
	}
	
	if ($c eq "adj")
	{
		return "Adjective";
	}
	
	if ($c eq "adv")
	{
		return "Adjverb";
	}

	return $_[0];
}

sub prtHash
{ 
	my $word = shift (@_);

	my %hash = ();
	while (@_)
	{
		my $pos = shift (@_);
		$hash{$pos} = shift (@_);
	}
	
	if (!(keys %hash))
    	{
		print "\nOooooooopppssss!!!!\nNo match found for \"$word\" (with the given constraints)!\nTry to relax the constraints(like part of speech tags, etc), if any.\n\n";
	}
	foreach my $key (sort keys %hash)
	{
		my $pos = getPOS($key);
		print "*********************\nPOS = $pos\n*********************\n";
		my $i=1;
		foreach my $def (sort keys (%{$hash{$key}}))
		{
			print "DEF $i: $def\n";
			$i++;
		}
		print "\n\n";
	}
}

sub prt1Hash
{
	my %hash = @_;
	my $i = 0;
	foreach my $key (sort keys %hash)
	{
		$i++;
		print "$key\t";
		print "\n";
	}

}

sub removeTagsFrom
{
    my $str = $_[0];
    while ($str =~ s/<.*?>/ /)
    {}
    return $str;
}

sub removeNewLines
{
	my $str = $_[0];

	while ($str =~ /\n/)
	{
		$str = $`." ".$';
		print "str = $`\n";
	getc();	
	}



	return ($str);
}

sub extractInfoFrom
{
	my %entries = @_;
    	my %outHash = ();

	
	foreach my $entry (keys %entries)
    	{
#		$entry = removeNewLines($entry);
		$entry =~ s/(.*?)<POS>//;
		$entry = $';

		while (my $str = getPOSFrom($entry))
		{
			
			$str =~ s/(.*?)<\/POS>//;
			my $pos = $1;
			#$entry=removeNewLines($entry);
			while ($str =~ /.*?<DEF>/)
			{
				$str = $';
				my $tempKey = "";
				if ($str =~ s/<\/DEF>//)
	    			{
					$str = $';
					$tempKey = $`;
				}
				$outHash{$pos}{removeTagsFrom($tempKey)} = 0;
			}
			
			if (!defined($outHash{$pos}))
			{
				%{$outHash{$pos}} = ();
			}
		}
	}



	return (%outHash);
}

sub getNextEntry
{
	my $file = $_[0];
	my $outStr = "";
	my $line = <$file>;

	if (!($line))
	{
		return $outStr;
	}


	while ($line !~ /^\<Entry\>/)
	{
		$line = <$file>;
		if (!($line))
		{
			return $outStr;
		}

	}


#	$line =~ s/\s$//;
	$outStr = $line;

	while ($line = <$file>)
	{
#	    $line =~ s/\s$//;

	    $outStr = "$outStr$line";
	    if ($line =~ /<\/Entry>/)
	    {
		last;
	    }

	}



	return $outStr;
}

sub getEntriesFor
{
    my $word = $_[0];
    my $file = $_[1];
    my %retHash=();
    my $found = 0;
    my $entry = getNextEntry($file);
    
    while ($entry)
    {
	if ($entry =~ /<((HWD)|(SPELLING))>$word<\/((HWD)|(SPELLING))>/i)
	{
	    $found = 1;
	    last;
	}
	else
	{
	    $entry = getNextEntry($file);
	}
    }
    
    if (!($found))
    {
	return (%retHash);
    }

    $retHash{$entry}=0;

    $entry = getNextEntry($file);
    while ($entry)
    {
	if ($entry !~ /<((HWD)|(SPELLING))>$word<\/((HWD)|(SPELLING))>/i)
	{
	    last;
	}
	else
	{ 
	    $retHash{$entry}=0;
	    $entry = getNextEntry($file);
	}
    }

    return (%retHash);
}

sub filterOn
{
	my $holdKey = $_[0];

	foreach my $key (keys %outVal)
	{
		if ($key ne $holdKey)
		{
			delete ($outVal{$key});
		}
	}
}

sub Lookup
{
    my $word = $_[0];
    %outVal = ();
    if (exists($index4Lookup{$word}))
    {
	foreach my $pos (keys %{$index4Lookup{$word}})
	{
	    foreach my $def (keys %{$index4Lookup{$word}{$pos}})
	    {
		$outVal{$pos}{$def} = 0;
	    }
	}
    }
    else
    {
	my $file = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
	
	$word =~ /^(.)/;
	
	if ("\U$1" eq "E")
	{
	    $file .= "e.sgm";
	}
	else
	{
	    $file .= "\U$1.SGM";	
	}
	
	if (!(open FILE,"<$file"))
	{
#	    print "Error: Invalid word specified - $word\n";
	    my %tempHash = ();
	    return ($word,%tempHash);
	}
	my %entries = getEntriesFor($word,FILE);
	
	close FILE;
	
	%outVal = extractInfoFrom(%entries);
	%{$index4Lookup{$word}} = %outVal;
    }

    if ($_[1])
    {
	if ($_[1] =~ /^n(oun)?$/i)
	{
		filterOn("n");
	} elsif ($_[1] =~ /^v(erb)?$/i)
	{
		filterOn("v");
	}elsif ($_[1] =~ /^adj(ective)?$/i)
	{
		filterOn("adj");
	}elsif ($_[1] =~ /^adv(erb)?$/i)
	{
		filterOn("adv");
	}
    }
    return ($word, %outVal);
}


####################################################
# Functions for stage 1, Second part, First subpart

sub getSemCodesFor
{
    my %entries = @_;
    my %outHash = ();

    foreach my $entry (keys %entries)
    {
	while ($entry)
	{
	    if ($entry !~ /<ACTIV>/)
	    {
		last;
	    }
	    $entry = $';
	    if ($entry !~ /<\/ACTIV>/)
	    {
		print "Error: Unbalance FIELD tags\n";
		return (%outHash);
	    }
	    my $sub = $`;
	    $entry = $';
	    $outHash{$sub} = 0;
	}
    }

    return (%outHash);
}

sub getSubCodesFor
{
    my %entries = @_;
    my %outHash = ();

    foreach my $entry (keys %entries)
    {
	while ($entry)
	{
	    if ($entry !~ /<FIELD>/)
	    {
		last;
	    }
	    $entry = $';
	    if ($entry !~ /<\/FIELD>/)
	    {
		print "Error: Unbalance FIELD tags\n";
		return (%outHash);
	    }
	    my $sub = $`;
	    $entry = $';
	    $outHash{$sub} = 0;
	}
    }

    return (%outHash);
}

sub getWordsWithSameSem
{
    my %outHash = ();
    if ($#_ == -1)
    {
	print "Error in the function getWordsWithSameSem: No parameter passed.\nA single word is expected. Quitting........\n";
	return (%outHash);
    }

    my $word = $_[0];
    $word =~ /^(.)/;
    my $file = "\U$1";
    if ($file !~ /[A-Z]/)
    {
	print "Error in the function getWordsWithSameSem: The word must begin with a valid character. The word you entered look like this -- $word.\nQuitting........\n";
	return (%outHash);
    }	

    my $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    my $ext = ".SGM";
    my $fh = FILEinGetWordsWithSameSem;

    if (!(open $fh, "<$path$file$ext"))
    {
	 if (!(open $fh, "<$path\L$file$ext"))
	 {
	     print "Error in the function getWordsWithSameSub: Open failed on file $file$ext\n";
	     return (%outHash);
	 }
     }
    
    my %entries = getEntriesFor ($word, $fh);
    close $fh;
    my %semCodes = getSemCodesFor (%entries);
    
    print "\nPlease Wait!!\nI am now searching the dictionary for you.\nThis may take a while.\n\n"; 

    if (!($flag4GWWSS))
    {
#Traverse all the files.
	print "Scanning the files......\nCreating the index......\n";
	$flag4GWWSS = 1;
	$file = 'A';
	$limit = 'Z'; $limit++;

       	while ($file ne $limit)
	{
	    if (!(open $fh, "<$path$file$ext"))
	    {
		if (!(open $fh, "<$path\L$file$ext"))
		{
		    next;
		}
	    }

	    while (my $entry = getNextEntry($fh))
	    {
		$index4GWWSS{$entry} = 0;
	    }
	    close $fh;
#	print "Finished reading words starting with $file.....\n";
	}
	continue
	{
	    $file++;
	}
	print "Index Created.......\n";

    }

    my %semMatches = ();

    print "Scanning the index......\n";

    foreach my $entry (keys %index4GWWSS)
    {
	if ($entry !~ /<HWD>/)
	{
	    next;
	}
	
	$entry = $';
	if ($entry !~ /<\/HWD>/)
	{
	    print "Error in function getWordsWithSameSub: Unbalanced HWD tags\n";
	    return (%outHash);
	}
	
	my $hwd = $`;
	$entry = $';

	foreach my $semCode (keys %semCodes)
	{
	    if ($entry !~ /<ACTIV>$semCode<\/ACTIV>/)
	    {
		next;
	    }
	    $semMatches{$semCode}{$hwd} = 0;
	}
    }	    

    return (%semMatches);
}

sub getWordsWithSameSub
{
    my %outHash = ();
    if ($#_ == -1)
    {
	print "Error in the function getWordsWithSameSub: No parameter passed.\nA single word is expected. Quitting........\n";
	return (%outHash);
    }

    my $word = $_[0];
    $word =~ /^(.)/;
    my $file = "\U$1";
    if ($file !~ /[A-Z]/)
    {
	print "Error in the function getWordsWithSameSub: The word must begin with a valid character. The word you entered look like this -- $word.\nQuitting........\n";
	return (%outHash);
    }	

    my $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    my $ext = ".SGM";
    my $fh = FILEinGetWordsWithSameSub;

    if (!(open $fh, "<$path$file$ext"))
    {
	 if (!(open $fh, "<$path\L$file$ext"))
	 {
	     print "Error in the function getWordsWithSameSub: Open failed on file $file$ext\n";
	     return (%outHash);
	 }
     }
    
    my %entries = getEntriesFor ($word, $fh);
    close $fh;
    my %subCodes = getSubCodesFor (%entries);
    
    print "\nPlease Wait!!\nI am now searching the dictionary for you.\nThis may take a while.\n\n"; 

    if (!($flag4GWWSS))
    {
#Traverse all the files.
	print "Scanning the files......\nCreating the index......\n";
	$flag4GWWSS = 1;
	$file = 'A';
	$limit = 'Z'; $limit++;

       	while ($file ne $limit)
	{
	    if (!(open $fh, "<$path$file$ext"))
	    {
		if (!(open $fh, "<$path\L$file$ext"))
		{
		    next;
		}
	    }

	    while (my $entry = getNextEntry($fh))
	    {
		$index4GWWSS{$entry} = 0;
	    }
	    close $fh;
#	print "Finished reading words starting with $file.....\n";
	}
	continue
	{
	    $file++;
	}
	print "Index Created.......\n";

    }

    my %subMatches = ();

    print "Scanning the index......\n";

    foreach my $entry (keys %index4GWWSS)
    {
	if ($entry !~ /<HWD>/)
	{
	    next;
	}
	
	$entry = $';
	if ($entry !~ /<\/HWD>/)
	{
	    print "Error in function getWordsWithSameSub: Unbalanced HWD tags\n";
	    return (%outHash);
	}
	
	my $hwd = $`;
	$entry = $';
	foreach my $subCode (keys %subCodes)
	{
	    if ($entry !~ /<FIELD>$subCode<\/FIELD>/)
	    {
		next;
	    }
	    $subMatches{$subCode}{$hwd} = 0;
	}
    }	    

    return (%subMatches);
}


####################################################
# Functions for stage 1, Second part, Second subpart

sub prtMatchingSubCodes
{
    my $fh = STDOUT; 

    if (exists ($_[0]))
    {
	if ($_[0] eq "__FILE")
	{
	    shift(@_);
	    my $file = shift (@_);
	    open FILEinPrtMatchingSubCodes, ">$file";
	    $fh = FILEinPrtMatchingSubCodes;
	}
    }

    my %hash = @_;
    if (!(keys %hash))
    {
	print "No word has the same subject code as that of the word you entered.\n";
	return;
    }
 
    foreach my $key (sort keys %hash)
    {
	print $fh "\n\nSubject code = $key:\n";
	foreach my $key2 (sort keys %{$hash{$key}})
	{
	    print $fh "\t\t$key2\n";
	} 
    }
}


sub prtMatchingDefs
{
    my $fh = STDOUT; 

    if ($_[0] eq "__FILE")
    {
	shift(@_);
	my $file = shift (@_);
	open FILEinPrtMatchingDefs, ">$file";
	$fh = FILEinPrtMatchingDefs;
    }

    my %hash = @_;
    if (!(keys %hash))
    {
	print "No matching definition\n";
	return;
    }

    print $fh "Matching definitions are:\n";
    foreach my $key (keys %hash)
    {
	print $fh "\n\nHead Word = $hash{$key}{HWD}\nPart Of Speech = $hash{$key}{POS}\nSubject Code = $hash{$key}{SUB}\nSemantic Code = $hash{$key}{SEM}\n\tDefinition = $key\n\n";
    } 
}

sub getData
{
    my $entry = $_[0];
    my %outHash = ();

    if ($entry !~ /<HWD>/)
    {
	return %outHash;
    }

    my $hwd = $';
    if ($hwd !~ /<\/HWD>/)
    {
	return %outHash;
    }
	
    $hwd = $`;

    if ($entry !~ /<POS>/)
    {
	return %outHash;
    }

    $entry = $';
    my %byPOS = ();
    
    while ($entry)
    {
	if ($entry =~ /<POS>/)
	{
	    $byPOS{$`} = 0;
	    $entry = $';
	}
	else
	{
	    $byPOS{$entry} = 0;
	    $entry ="";
	}
    }

    foreach my $key (keys %byPOS)
    {
	if (!($key))
	{
	    next;
	}
#Get part of speech
	$key =~ /<\/POS>/;
	my $pos = $`;
	my $entry = $key;
	if ($entry !~ /<(Sense|Subsense)>/)
	{
	    next;
	}

	$entry = $';
	my %bySub = ();
    
	while ($entry)
	{
	    if ($entry =~ /<(Sense|Subsense)>/)
	    {
		$bySub{$`} = 0;
		$entry = $';
	    }
	    else
	    {
		$bySub{$entry} = 0;
		$entry ="";
	    }
	}

	foreach my $key (keys %bySub)
	{
	    my $str = $key;
	    my $sub = "";
#Get the subject code
	    if ($str =~ /<FIELD>/)
	    {
		$sub = $';
		$sub =~ /<\/FIELD>/;
		$sub = $`;
	    }

	    my $sem = "";
#Get the semantic code
	    if ($str =~ /<ACTIV>/)
	    {
		$sem = $';
		$sem =~ /<\/ACTIV>/;
		$sem = $`;
	    }


	    while ($str)
	    {	
		if ($str !~ /<DEF>/)
		{
		    last;
		}

		$str = $';


		if ($str !~ /<\/DEF>/)
		{
		    print "Error: No closing DEF tag\n";
		    exit (0);
		}
		my $def = $`;
		$str = $';

		#clean the definition def
		while ($def =~ /<(.*?)>/)
		{
			my $head = $`;
			my $tail = $';
			$def = $head.$tail;
		}
		$outHash{$def}{POS}=$pos;
		$outHash{$def}{SUB}=$sub;
		$outHash{$def}{SEM}=$sem;
		$outHash{$def}{HWD}=$hwd;
	    }
	}
    }
    return (%outHash);
}

sub createIndex
{
    if ($flag4SID)
    {
	return (%index4SID);
    }

    $flag4SID = 1;
    my $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    my $file = 'A'; my $ext = ".SGM";
    my $limit = 'Z'; $limit++;
    my $fh = FILEinCreateIndex;
 
#	print "Scanning the files......\nCreating the index......\n";
    
    while ($file ne $limit)
    {
	if (!(open $fh, "<$path$file$ext"))
	{
	    if (!(open $fh, "<$path\L$file$ext"))
	    {
		next;
	    }
	}
	
	while (my $entry = getNextEntry($fh))
	{
	    my %data = getData($entry);
	    #store data into index
	    foreach my $def (keys %data)
	    {
		$index4SID{$def}{POS}=$data{$def}{POS};
		$index4SID{$def}{SUB}=$data{$def}{SUB};
		$index4SID{$def}{SEM}=$data{$def}{SEM};
		$index4SID{$def}{HWD}=$data{$def}{HWD};
	    }
	}
	close $fh;
    }
    continue
    {
	$file++;
    }
#	print "Index Created.......\n";
    return (%index4SID);
}    

sub bypassCreateIndex
{
    $flag4SID = 1;
}

sub searchInDefs
{
    my %outHash = ();
    if ($#_ == -1)
    {
	return (%outHash);
    }

    my @words = split (/([\s,])+/, $_[0]);
    if (!@words)
    {
	return (%outHash);
    }

#    print "\nPlease Wait!!\nI am now searching the dictionary for you.\nThis may take a while.\n\n"; 
 

    if (!($flag4SID))
    {
#	print "I am heresid = $flag4SID\n";
#	getc();
	createIndex();
#	$flag4SID = 1;
#	my $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
#	my $file = 'A'; my $ext = ".SGM";
#	my $limit = 'Z'; $limit++;
#	my $fh = FILEinSRCHinDEFS;

#	print "Scanning the files......\nCreating the index......\n";


#	while ($file ne $limit)
#	{
#	    if (!(open $fh, "<$path$file$ext"))
#	    {
#		if (!(open $fh, "<$path\L$file$ext"))
#		{
#		    next;
#		}
#	    }
	
#	    while (my $entry = getNextEntry($fh))
#	    {
#		my %data = getData($entry);
#		#store data into index
#		foreach my $def (keys %data)
#		{
#		    $index4SID{$def}{POS}=$data{$def}{POS};
#		    $index4SID{$def}{SUB}=$data{$def}{SUB};
#		    $index4SID{$def}{SEM}=$data{$def}{SEM};
#		    $index4SID{$def}{HWD}=$data{$def}{HWD};
#		}
#	    }
#	    close $fh;
#	}
#	continue
#	{
#	    $file++;
#	}
#	print "Index Created.......\n";
    }
    
#    print "Scanning the index......\n";

    foreach my $def (keys %index4SID)
    {
	my @tempWords = @words;
	my $accept = 1;
	while (my $word = shift (@tempWords))
	{
	    if ($def !~ /\b$word(s)?\b/i)
	    {
		$accept = 0;
		last;
	    }
	}
	
	if (!($accept))
	{
	    next;
	}
	
	$outHash{$def}{POS}=$index4SID{$def}{POS};
	$outHash{$def}{SUB}=$index4SID{$def}{SUB};
	$outHash{$def}{SEM}=$index4SID{$def}{SEM};
	$outHash{$def}{HWD}=$index4SID{$def}{HWD};
    }	    
    return (%outHash);
}

sub prtAllPOS
{
    my %ip = ();
    %ip = @_;
    foreach (sort keys %ip)
    {
	print "$_\n";
    }
}

sub getAllPOS
{
    my %outHash = ();
    if (!$flag4SID)
    {
	createIndex();
    }

    foreach my $def(keys %index4SID)
    {
	my $key = $index4SID{$def}{POS};
	if ($key =~ /</)
	{
	    next;
	}
	$outHash{$key} = 0;
    }
    return %outHash;
}


# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

ldoc - Perl Interface to Longman's Dictionary of Contemporary Language

=head1 SYNOPSIS

  use ldoc;

EXAMPLE 1:
  my @out = Lookup ("dye");
  prtHash(@out);
  
EXAMPLE 2:
  my @out = Lookup ("dye","n"); 
  OR
  my @out = Lookup ("dye","noun");
  OR
  my @out = Lookup ("dye","NouN");
  OR
  my @out = Lookup ("dye","noUn");

  prtHash(@out);

EXAMPLE 3:
   my @out = searchInDefs("height object");
   OR
   my @out = searchInDefs("height, object");

   prtMatchingDefs (@out); 
   OR
   prtMatchingDefs ("__FILE",$filename,@out); 

EXAMPLE 4:
   my @out = getWordsWithSameSub ("wolf");

   prtMatchingSubCodes(@out);
   OR 
   prtMatchingSubCodes(getWordsWithSameSub ("wolf"));
   OR
   prtMatchingSubCodes("__FILE", $filename,getWordsWithSameSub ("wolf"));

EXAMPLE 5:
   my %pos = getAllPOS();
   prtAllPOS(%pos);
   OR 
   prtAllPOS(getAllPOS());


=head1 RESTRICTIONS

There are  a few restrictions. Because we are not able to install the 
module (lacking the super-user privileges), we are not able to run it
from  every  single  location. Therefore, any  test  program  must be 
EXECUTED from the same directory where the module resides, though it 
can stay anywhere. 


=head1 ABSTRACT

  LDOCE is a machine readable dictionary. It has the data stored
  in 26 files. A file "X.SGM" (value of X in Upper Case) has the 
  data for all the words starting with the letter 'X' where X is 
  a variable that can range from A to Z or a to z. This has one 
  exception -- "e.sgm". If a word starts from 'e' of 'E' it is 
  found likely to be found in "e.sgm" rather than "E.SGM".


=head1 DESCRIPTION

=head2 EXPORT

The module exports the following functions.


=head3 1) Lookup(word)

       Searches the "word" in the Longman's Dictionary and returns all 
       the parts of speech and all the definitions associated with each. 


=head3 2) Lookup(word,POS)

       Searches the "word" in the Longman's Dictionary and returns all 
       the definitions associated with the given part of speech "POS".

=head3 3) prtHash(<output of lookup>)

       Prints the output data structure given out by Lookup function.

=head3 4) searchInDefs(Set of words)

       Returns, in the form of a complex hash, all the definitions 
       containing the set of words passed. Also returns the part of 
       speech, subject code, semantic code and the head word associated 
       with the definition.

=head3 5) prtMatchingDefs(output of searchInDefs(Set of words))

       Prints on STDOUT the data structure generated by searchInDefs 
       function.

=head3 6) prtMatchingDefs("__FILE", filename, output of searchInDefs(Set of words))

       Prints to the file "filename" the data structure generated by 
       searchInDefs function.

=head3 7) getWordsWithSameSub (word)

       Returns all the word that share some subject code with the 
       word passed.

=head3 8) prtMatchingSubCodes(output of getWordsWithSameSub function)

       Prints on STDOUT the data structure returned by the function 
       getWordsWithSameSub

=head3 9) prtMatchingSubCodes("__FILE", filename, output of getWordsWithSameSub function)

       Prints to the file filename the data structure returned by the 
       function getWordsWithSameSub

=head3 10) getAllPos()

       Returns a hash whose keys are the parts of speech available in LDOCE.

=head3 11) prtAllPos()

       Prints the hash returned by the function getAllPOS().


=head1 SEE ALSO

perldoc BigMac

=head1 AUTHORS

Ashutosh A Nagle, E<lt>nagl0033@d.umn.eduE<gt>
Paul Gordon,E<lt>gord0156@d.umn.eduE<gt> 
Archana Bellamkonda, E<lt>bell0331@d.umn.eduE<gt>
and
Rashmi Kankaria, E<lt>kank0005@d.umn.eduE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by Ashutosh A Nagle, Paul Gordon, Rashmi Kankaria and Archana Bellamkonda

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
