package webSearch;

#----------------------------------------------------------------------
# Cristal:
#	Archana Bellamkonda
#   Rashmi V Kankaria
#   Ashutosh A Nagle
#   Paul J Gordon
# 
# 12/16/2002
# Final Project 
# CS 8761 - Natural Language Processing - Fall 2002 
#
# This module takes as input one or more words.  It uses these words
# as a source for a web query.  The returned pages are then filtered for only
# those sentences containing the original word or words.
#
# The driver function is master.  It is located at line 478.
#
#-------------------------------------------------------------------------------

use 5.008;
use warnings;
use LWP::UserAgent ;
use URI::Escape;
my $pages = 5;
require Exporter;

##Revome Later
#$neverB4=1;
##Till here

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use webSearch ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(master
	
);

our $VERSION = '0.01';


# Preloaded methods go here.

sub getPage
{
    my $fname = $_[0];
    my $url = $_[1];
    my $fh = FILEinGetPage;
    my %option = ("timeout" => 10);
    my $ua = LWP::UserAgent->new(%option);
    $ua->agent("$0/0.1 " . $ua->agent);

    my $req = HTTP::Request->new(GET => $url);

    $req->header('Accept' => 'text/html');
    
# send request
    open($fh , ">$fname");
    system ( "chmod 777 $fname" ) ;
    my $res = $ua->request($req, "$fname" );
    
# check the outcome
    if ($res->is_success) 
    {
#	print " getPage:content copied into file\n"; #return file handle
    } else 
    {
#	print "Error in getPage: " . $res->status_line . "\n";
    }

    close($fh);
}


sub extractLinksFrom
{
    my $str = shift(@_);
    my @out = ();

    if (!defined ($str))
    {
	return @out;
    }
    my $index = 0;

    while ($str =~ /<a\W/i)
    { 
	$str = $';

	if ($str !~ /\>/)
	{
	    next;
	}

	my $posLink = $`;
	$str = $';

	if ($posLink !~ /status=\'http:\/\//i)
	{
	    next;
	}

	$posLink = "http://".$';

	if ($posLink !~ /\'/)
	{
	    next;
	}

	$posLink = $`;
	
	$out[$index++] = $posLink;
    }
    return @out;
}

sub generateFirstPage 
{
    my $fname = $_[0];
    my $phrase = $_[1];

    my $ua = LWP::UserAgent->new;
    $ua->agent("$0/0.1 " . $ua->agent);

    my $url = "http://www.altavista.com/sites/search/web?q=%22".uri_escape($phrase)."%22&kl=XX";
    my $req = HTTP::Request->new(GET => $url);

    $req->header('Accept' => 'text/html');
    
# send request
    open( SH, ">$fname");
    system ( "chmod 777 $fname" ) ;
    my $res = $ua->request($req, "$fname" );
    
# check the outcome
    if ($res->is_success) 
    {
#	print " content copied into file\n"; #return file handle
    } else 
    {
	print "Error: " . $res->status_line . "\n";
    }
    
    close(SH);
}

sub generateNextPage
{ 
    my $fname = $_[0];
    my $fh = $_[1];
    
    while( $str = <$fh> ) 
    {
	my $link = "";
	my $txt = "";
	while( $str =~ m/\<a href=\"(.*?)\>(.*?)\<\/a\>/ ) 
	{
	    $link = $1;
	    $txt = $2;
	    $str = $';
	    if( $txt =~ m/Next &gt;&gt;/ ) 
	    {

		$base = "http://www.altavista.com";
		open( FH, ">$fname");
                system ("chmod 777 $fname") ;
		close(FH);
		
		my $ua = LWP::UserAgent->new;
		$ua->agent("$0/0.1 " . $ua->agent);
		
		my $url = URI->new_abs($link,$base);
		
		my $req = HTTP::Request->new(GET => $url);
		
		$req->header('Accept' => 'text/html');
	    
# send request
		my $res = $ua->request($req, "$fname" );
		if ($res->is_success) 
		{
#		    print " content copied into file\n"; #return file handle
		    return 1;
		} else 
		{
		    print "Error: " . $res->status_line . "\n";
		    return 0;
		}
	    }
	}
    }
    return 0;
}

sub getPagesFor
{
	if (!(exists($_[0])))
	{
		return;
	}

	my $phrase = $_[0];

	if (!(exists($_[1])))
	{
		return;
	}

	my $masterStore = $_[1]; #Filename

	generateFirstPage("SearchPage",$phrase);

	$pages--;
	my $fh = FILEinGetPagesFor;
	@linkStore = ();
	while (1)
	{
	    if (!(open $fh, "<SearchPage"))
	    {
		print "Open failed on file SearchPage\n";
		last;
	    }
	    system ( "chmod 777 SearchPage" ) ;

	    #Advance till the string "Altavista found - - - - "

	    while (my $line = <$fh>)
	    {
		if ($line =~/Altavista found \d+(,\d+)* results/i)
		{
		    last;
		}
	    }
	    my $text = "";

	    while (my $line = <$fh>)
	    {
		if ($line =~ /Add your web site\'s pages to AltaVista search results with/i)
		{
		    last;
		}
		$text .=$line;
	    }
	   

	    my @out = extractLinksFrom($text);
	    my $i = $#linkStore;
	    foreach my $link (@out)
	    {
		$linkStore[++$i] = $link;
	    }      
	    
	    if (!$pages)
	    {
		last;
	    }

	    if (!(generateNextPage("SearchPage", $fh)))
	    {
		print "I come here\n";
		last;
	    }
	    $pages--;
	}
	unlink "SearchPage";


#Now right all the html pages one below the other.

	my $allPages = AllPagesFileInGetPagesFor;
	open $allPages, ">$masterStore";
	system( "chmod 777 $masterStore") ;
	my $tempFH = TempFHInGetPagesFor;

	foreach my $link (@linkStore)
	{
	    getPage("htmlPage",$link);

###Remove later
#	    $neverB4--;	    
#	    if ($neverB4 == 0)
#	    {
#		exit 0;
#	    }


##Till here
	    open $tempFH, "<htmlPage";
	    while (<$tempFH>)
	    {
		print $allPages $_;
	    }
	    close $tempFH;
	    open $tempFH, ">htmlPage";
	    system("chmod 777 htmlPage" ) ;
	    close $tempFH;
	}

	close $allPages;
}

#######Paul's Module Starts

sub sentenceParse { 
my $file = shift ;					# filename
my @checkList ;						# list of words to search for
while ( defined( $_ = shift ) ) {	# gather up the list from 
	push @checkList, uc($_) ;			# the command arguements
	}								# 
my $fh = SentenceParseFileOne ;		# filehandle variable
my $flag = 0 ;						# marks end of input file
my @tmpSents ;						# 
my @line ;							# all sentences
my $tmpline ;						#
my @final ;							# matched sentences


# Source of html code to be parsed into sentences
open $fh, "$file" || die "Can't open test.doc for reading: $!\n" ;
system( "chmod 777 $file" ) ;

while ( $_ = <$fh> ) {
	$tmpline="";							# Re-initialize variable
	until ( $_ =~ m/<[bB][Oo][Dd][Yy]/ ) {  # only process within body
			if(defined($_ = <$fh>) ) {		# if !EOF, get another line
			}
			else { $flag = 1 ; last ; }		# else set EOF flag
	}
	if( $flag == 1 ) { last ; }				# Done, so exit.
	# Make body one long string -- to better process multi-line tags.
	#
	until( $_ =~ m/<\/[bB][Oo][Dd][Yy]/) {
		if(defined($_=<$fh>) ) {
			$tmpline.=$_ ;					
		} 
		else { last ; } 
	}
	# switch sting back to \$_ for easier processing
	#
	$_ = $tmpline ; 
	s/\s*<.*?>\s*/ /sg ;					# Remove multiline tags
	#s/^\s+// ;
	s/^.*?>\s*/ / ;							# Not all tags seem to have pairs
	s/\s*<.*$/ / ;							#	
	@tmpSents = split /\s{2,}|\n/, $_ ;		# Now that tags are gone, split back up
		foreach (@tmpSents) {				
		if ( $_ eq "" ) { next ; }			# Don't process empty lines
		if( /\&nbsp;\s*/) {					# remove formating
			s/&nbsp;\s*//g ;				
			if( $_ eq "" ) { next ; }
			else { $_.="." ; }				# Consider line with this 
		}									# formatting a sentence
		if( /\&\#8226;\s*/ ) {				# Same is true for this formatting 
			s/\&\#8226;\s*//g ; 
			if( $_ eq "" ) { next ; }
			if(!/[\.\?!]$/){ $_.="." ; }	# Don't double punctuate
		}
		s/\&.*?;\s*\.?//g ;					# Remove remaining formatting
		# If less than three words long and starting with a capital
		# or not ending with sentence ending punctuation,
		# consider a sentence.
		#
		if ( !/\w+\s+\w+\s+\w+/ && ( /^[A-Z]/ || !/[\.\?!]$/ ) ) { $_.="." ; }
		
		if( /^\n$/ && $sentence ) {		   # For titles, chapter headings
			$sentence.=$tmp ;              # (sentences w/out ending punct. )
			# Decided it's a sentence boundary, so make upper case, and
			# do a little cleanup.
			$sentence = uc($sentence);     # All caps
			#$sentence =~ s/\-+/ /g ;      # Make one or more hyphens a space.
			#$sentence =~ s/[^A-Z0-9% ]//g ;    # Get rid of punctuation
			$sentence =~ s/\s+$// ;        # Get rid of ending spaces
			$sentence =~ s/\s{2,}/ /g ;
			$sentence =~ s/^\s+// ;
			if( length( $sentence ) > 20 ) { push @line, $sentence ; } 
			$sentence="" ;
			$tmp="" ;
			next ;
			}  
    
		foreach( /\b[A-Za-z0-9\'\"]+\b\W*/g ) {# Seperate lines into words, w/ trailing spaces, punct.
			if( !$tmp ) {                      # Do ckeck on previous word, so $_ can be used to check 
				$tmp = $_ ;                    # next word.
				next ; 
			}
	
			if  ($tmp =~ /[\.\?!]/) {	       # Check for sentence ending puntc.
				if ( $tmp =~ /[Dd]r\.|[Mm][rs]s*\.|\b[A-Z]\.|[JjSs][Rr]\.|jan\.|feb\.|mar\.|
							   apr\.|jul\.|aug\.|sept?\.|oct\.|nov\.|dec\./i ) { 
					$sentence.=$tmp ;  # If word matches common abrv., continue.
				}
	    
				else{									# Sentence end, so add to array.
					$sentence.=$tmp ;
					# Decided it's a sentence boundary, so make upper case, and
					# do a little cleanup.
					$sentence = uc($sentence);			# All caps
					#$sentence =~ s/\-+/ /g ;			# Make one or more hyphens a space.
					#$sentence =~ s/[^A-Z0-9% ]//g ;    # Get rid of punctuation
					$sentence =~ s/\s+$// ;				# Get rid of ending spaces
					$sentence =~ s/\s{2,}/ /g ;
					$sentence =~ s/^\s+// ;
					if( length( $sentence ) > 20 ) { 
						push @line, $sentence ; 
					}
					$sentence="" ; }
				}
			else {                                 # If no sentence ending punc,
				$sentence.=$tmp ;                  # keep looking for end of sentecne.
			}
			$tmp = $_ ;                            # Update $tmp
		}
    
		$tmp.=" " ;		                       # Add space at end of line.
		#if ($sentence) { $tmp.=" " ; }

	}
	# Get the last word
	$sentence.=$tmp ;#
	$sentence = uc($sentence);     # All caps
	$sentence =~ s/\s{2,}/ /g ;
	$sentence =~ s/^\s+// ;
	if( length( $sentence ) > 20 ) { push @line, $sentence ; }



} #while loop

#print "number of sentences: ", scalar @line, "\n" ;

#foreach  (@line) {
#	print "*********\n$_\n*********\n" ; 
#}

# Search each parsed sentence for match with list of words
# if there is a match, add to returned array.
#
foreach $line (@line) 
{ 
    foreach  ( @checkList ) 
    {
	if( $line =~ /$_/ ) 
	{
	    push @final, $line ;
	    last ;
	}
    }
}



#print "Number of sentences returned:", scalar @final, "\n" ;
	
#foreach  (@final) 
#{
#	print "*********\n$_\n*********\n" ; 
#}

return @final ;

}

#######Paul's Module ends.

sub master
{
    $pages = 5;
    my @words = split (/\s+/, $_[0]);
    my $phrase = $_[0];
    my $f = "AllCoalPages";
    getPagesFor($phrase,$f);
#    print "Entr the filename\n";
#    $f = <>;
    my @out = ();
    @out = sentenceParse($f,@words);
    unlink $f;
    return (@out);
}


# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

webSearch - Little tool that access web through the search engine "Altavista.com" for a given set of words.

=head1 SYNOPSIS

  use webSearch;
  EXAMPLE:
    master(<S>)
    Where,
        <S> is the set of words that the user wants to search on the web.


=head1 ABSTRACT

      This is a very useful tool to get the data from the web, probably the 
    largest data bank.

=head1 DESCRIPTION

    This module exports the function called "master", which takes in a 
    parameter, which is the set of words to be searched on web.

=head2 EXPORT

=head3 master (Set of words)

Usage : As stated above.

=head1 AUTHOR

Sporting Cristal

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by Ashutosh A Nagle

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
